/***************************************************************************
 *   Copyright (C) 2007 by Tobias Schwarz   *
 *   mail@tobias-schwarz.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   In addition, as a special exception, the copyright holders give       *
 *   permission to link the code of this program with any edition of       *
 *   the Qt library by Trolltech AS, Norway (or with modified versions     *
 *   of Qt that use the same license as Qt), and distribute linked         *
 *   combinations including the two.  You must obey the GNU General        *
 *   Public License in all respects for all of the code used other than    *
 *   Qt.  If you modify this file, you may extend this exception to        *
 *   your version of the file, but you are not obligated to do so.  If     *
 *   you do not wish to do so, delete this exception statement from        *
 *   your version.                                                         *
 ***************************************************************************/

#include <QtGui>
#include "programWindows.h"

void kabiview::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "graph");
}

void kalignment::on_ProgramComboBox_currentIndexChanged(const QString &text)
{
   AlternativesLabel->setEnabled(false);
   AlternativesSpinBox->setEnabled(false);
   AlignmentWidthSpinBox->setEnabled(false);
   AlignmentWidthLabel->setEnabled(false);
   WordLengthSpinBox->setEnabled(false);
   WordLengthLabel->setEnabled(false);
   EndweightCheckBox->setEnabled(false);
   EndGapOpenPenaltyLabel->setEnabled(false);
   EndGapOpenPenaltyDoubleSpinBox->setEnabled(false);
   EndGapExtensionPenaltyLabel->setEnabled(false);
   EndGapExtensionPenaltyDoubleSpinBox->setEnabled(false);
   MinimumScoreLabel->setEnabled(false);
   MinimumScoreDoubleSpinBox->setEnabled(false);
   ErrorfileLabel->setEnabled(false);
   ErrorfileLineEdit->setEnabled(false);
   ErrorfileSaveAsPushButton->setEnabled(false);
   BriefIdentityAndSimilarityCheckBox->setEnabled(false);
   if (text == "water") {
      BriefIdentityAndSimilarityCheckBox->setEnabled(true);
      PenaltiesStackedWidget->setCurrentIndex(0);
   } else if (text == "needle" || text == "needleall") {
      BriefIdentityAndSimilarityCheckBox->setEnabled(true);
      PenaltiesStackedWidget->setCurrentIndex(0);
      EndweightCheckBox->setEnabled(true);
      EndGapOpenPenaltyLabel->setEnabled(true);
      EndGapOpenPenaltyDoubleSpinBox->setEnabled(true);
      EndGapExtensionPenaltyLabel->setEnabled(true);
      EndGapExtensionPenaltyDoubleSpinBox->setEnabled(true);
      if (text == "needleall") {
         MinimumScoreLabel->setEnabled(true);
         MinimumScoreDoubleSpinBox->setEnabled(true);
         ErrorfileLabel->setEnabled(true);
         ErrorfileLineEdit->setEnabled(true);
         ErrorfileSaveAsPushButton->setEnabled(true);
      }
   } else if (text == "matcher") {
      AlternativesLabel->setEnabled(true);
      AlternativesSpinBox->setEnabled(true);
      PenaltiesStackedWidget->setCurrentIndex(1);
   } else if (text == "supermatcher") {
      AlignmentWidthSpinBox->setEnabled(true);
      AlignmentWidthLabel->setEnabled(true);
      WordLengthSpinBox->setEnabled(true);
      WordLengthLabel->setEnabled(true);
      PenaltiesStackedWidget->setCurrentIndex(0);
   } else if (text == "stretcher") {
      PenaltiesStackedWidget->setCurrentIndex(1);
   }
   setEmbossApp(text);
}

void kalignment::beforeRunningProgram()
{
   QString num;
   if (PenaltiesStackedWidget->currentIndex() == 0) {
      num.setNum(GapOpenPenaltyDoubleSpinBox->value());
      programConfiguration.append("-gapopen="+num);
      num.setNum(GapExtensionPenaltyDoubleSpinBox->value());
      programConfiguration.append("-gapextend="+num);
   } else {
      if (GapOpenPenaltySpinBox->value() != 0) {
         num.setNum(GapOpenPenaltyDoubleSpinBox->value());
         programConfiguration.append("-gapopen="+num);
      }
      if (GapExtensionPenaltySpinBox->value() != 0) {
         num.setNum(GapExtensionPenaltyDoubleSpinBox->value());
         programConfiguration.append("-gapextend="+num);
      }
   }
}

void kanalyzeseq::setEmbossApp(const QString &appName)
{
   WordCountGroupBox->setChecked(false);
   SeqmatchallGroupBox->setChecked(false);
   RegularExpressionSearchGroupBox->setChecked(false);
   PatternSearchGroupBox->setChecked(false);
   ChipsGroupBox->setChecked(false);
   MarscanGroupBox->setChecked(false);
   GeeCeeGroupBox->setChecked(false);
   GarnierGroupBox->setChecked(false);
   CuspGroupBox->setChecked(false);
   CaiGroupBox->setChecked(false);
   PscanGroupBox->setChecked(false);
   PepstatsGroupBox->setChecked(false);
   if (appName == "wordcount") {
      WordCountGroupBox->setChecked(true);
      qualifierNum = "";
   } else if (appName == "seqmatchall") {
      SeqmatchallGroupBox->setChecked(true);
      qualifierNum = "0";
   } else if (appName == "dreg") {
      RegularExpressionSearchGroupBox->setChecked(true);
      InputComboBox->setCurrentIndex(0);
   } else if (appName == "preg") {
      MotifIsInPROSITEFormatCheckBox->setChecked(false);
      RegularExpressionSearchGroupBox->setChecked(true);
      InputComboBox->setCurrentIndex(1);
   } else if (appName == "patmatdb") {
      MotifIsInPROSITEFormatCheckBox->setChecked(true);
      RegularExpressionSearchGroupBox->setChecked(true);
      InputComboBox->setCurrentIndex(1);
   } else if (appName == "fuzznuc") {
      PatternSearchGroupBox->setChecked(true);
      InputComboBox2->setCurrentIndex(0);
   } else if (appName == "fuzzpro") {
      PatternSearchGroupBox->setChecked(true);
      InputComboBox2->setCurrentIndex(1);
   } else if (appName == "fuzztran") {
      PatternSearchGroupBox->setChecked(true);
      InputComboBox2->setCurrentIndex(2);
   } else if (appName == "marscan") {
      MarscanGroupBox->setChecked(true);
      qualifierNum = "2";
   } else if (appName == "geecee") {
      GeeCeeGroupBox->setChecked(true);
      qualifierNum = "";
   } else if (appName == "garnier") {
      GarnierGroupBox->setChecked(true);
      qualifierNum = "2";   
   } else if (appName == "chips") {
      ChipsGroupBox->setChecked(true);
   } else if (appName == "cusp") {
      CuspGroupBox->setChecked(true);
      qualifierNum = "";
   } else if (appName == "cai") {
      CaiGroupBox->setChecked(true);
   } else if (appName == "pscan") {
      PscanGroupBox->setChecked(true);
      qualifierNum = "";
   } else if (appName == "pepstats") {
      PepstatsGroupBox->setChecked(true);
      qualifierNum = "";
   }
   if (appName == "chips" || appName == "cai") {
      InputFileLineEdit->setToolTip("seqall");
      qualifierNum = "";
   } else {
      InputFileLineEdit->setToolTip("sequence");
   }
   kprogramWindow::setEmbossApp(appName);
}

void kanalyzeseq::on_InputComboBox_currentIndexChanged(int index)
{
   qualifierNum = "3";
   if (index == 0) {
      MotifIsInPROSITEFormatCheckBox->setEnabled(false);
      RegularExpressionLineEdit->setToolTip("pattern");
      kprogramWindow::setEmbossApp("dreg");
   } else {
      MotifIsInPROSITEFormatCheckBox->setEnabled(true);
      on_MotifIsInPROSITEFormatCheckBox_stateChanged(MotifIsInPROSITEFormatCheckBox->checkState());
   }
}

void kanalyzeseq::on_MotifIsInPROSITEFormatCheckBox_stateChanged(int state)
{
   if (state == Qt::Checked) {
      RegularExpressionLineEdit->setToolTip("motif");
      kprogramWindow::setEmbossApp("patmatdb");
   } else {
      RegularExpressionLineEdit->setToolTip("pattern");
      kprogramWindow::setEmbossApp("preg");
   }
}

void kanalyzeseq::on_InputComboBox2_currentIndexChanged(int index)
{
   qualifierNum = "2";
   switch (index) {
    case 0: kprogramWindow::setEmbossApp("fuzznuc");
            FramesToTranslateLabel->setEnabled(false);
            FramesComboBox->setEnabled(false);
            GeneticCodeLabel->setEnabled(false);
            GeneticCodeComboBox->setEnabled(false);
            SearchComplementaryStrandCheckBox->setEnabled(true);
            break;
    case 1: kprogramWindow::setEmbossApp("fuzzpro");
            FramesToTranslateLabel->setEnabled(false);
            FramesComboBox->setEnabled(false);
            GeneticCodeLabel->setEnabled(false);
            GeneticCodeComboBox->setEnabled(false);
            SearchComplementaryStrandCheckBox->setEnabled(false);
            break;
    case 2: kprogramWindow::setEmbossApp("fuzztran");
            FramesToTranslateLabel->setEnabled(true);
            FramesComboBox->setEnabled(true);
            GeneticCodeLabel->setEnabled(true);
            GeneticCodeComboBox->setEnabled(true);
            SearchComplementaryStrandCheckBox->setEnabled(false);
            break;
   }
}

void kanalyzeseq::on_OutfileAssociatedQualifiersPushButton2_clicked()
{
   if (qualifierNum == "0") {
      openAAQForm("2");
   } else if (qualifierNum == "2" || qualifierNum == "3") {
      openOAQForm(qualifierNum);
   } else if (qualifierNum == "")
      QMessageBox::information(this, objectName(),tr("This program doesn't support any outfile associated qualifiers."));
}

void kanalyzeseq::beforeRunningProgram()
{
   if (embossApp() == "fuzztran") {
      programConfiguration.append("-table="+GeneticCodeComboBox->currentText().section(" ", 0, 0));
      programConfiguration.append("-frame="+FramesComboBox->currentText().section(" ", 0, 0));
   } else if (embossApp() == "cai") {
      programConfiguration.append("-cfile="+CodonUsageFileComboBox->currentText().section(" ", 0, 0));
   }
}

void kbacktranambig::beforeRunningProgram()
{
   programConfiguration.append("-table="+GeneticCodeComboBox->currentText().section(" ", 0, 0));
}

void kbanana::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "graph");
}

void kcharge::beforeRunningProgram()
{
   if (CreateGraphGroupBox->isChecked()) completeOutputFiles(OutputFileLineEdit2, "graph");
}

void kchecktrans::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "feat");
   completeOutputFiles(OutputFileLineEdit3, "seq");
}

void kcoderet::beforeRunningProgram()
{
   completeOutputFiles(CodingNucleotidesLineEdit, "seq1");
   completeOutputFiles(MessengerRNALineEdit, "seq2");
   completeOutputFiles(TranslatedProteinLineEdit, "seq3");
   completeOutputFiles(NonCodingNucleotidesLineEdit, "seq4");
}

void kcons::beforeRunningProgram()
{
   QString num;
   if (PluralityDoubleSpinBox->value()!=-1) {
      num.setNum(PluralityDoubleSpinBox->value());
      programConfiguration.append("-plurality="+num);
   }
   if (UpperCaseDoubleSpinBox->value()!=-1) {
      num.setNum(UpperCaseDoubleSpinBox->value());
      programConfiguration.append("-setcase="+num);
   }
}

void kcpgplot::on_ProgramComboBox_currentIndexChanged(const QString &text)
{
   bool setTo;
   if (text == "cpgplot") setTo = true; else setTo = false;
      ShowGraphGroupBox->setEnabled(setTo);
      ShiftSpinBox->setEnabled(!setTo);
      ShiftLabel->setEnabled(!setTo);
      FeatureFileLabel->setEnabled(setTo);
      FeatureFileLineEdit->setEnabled(setTo);
      SaveFeatureFileAsPushButton->setEnabled(setTo);
      OutfeatAssociatedQualifiersPushButton->setEnabled(setTo);
      GraphLabel->setEnabled(setTo);
      GraphLineEdit->setEnabled(setTo);
      SaveGraphAsPushButton->setEnabled(setTo);
      GraphAssociatedQualifiersPushButton->setEnabled(setTo);
   setEmbossApp(text);
}

void kcpgplot::beforeRunningProgram()
{
   completeOutputFiles(FeatureFileLineEdit, "feat");
   completeOutputFiles(GraphLineEdit, "graph");
}

void kcpgreport::on_ProgramComboBox_currentIndexChanged(const QString &text)
{
   bool setTo;
   if (text == "cpgreport") setTo = true; else setTo = false;
      FeatureFileLabel->setEnabled(setTo);
      FeatureFileLineEdit->setEnabled(setTo);
      SaveFeatureFileAsPushButton->setEnabled(setTo);
      OutfeatAssociatedQualifiersPushButton->setEnabled(setTo);
   setEmbossApp(text);
}

void kcpgreport::beforeRunningProgram()
{
   if (ProgramComboBox->currentText() == "cpgreport") completeOutputFiles(FeatureFileLineEdit, "feat");
}

void kdan::beforeRunningProgram()
{
   if (GraphGroupBox->isChecked()) programConfiguration.append("-goutfile="+OutputFileLineEdit->text());
}

void kdensity::beforeRunningProgram()
{
   if (QuadRadioButton->isChecked()) {
      programConfiguration.append("-quad");
      programConfiguration.append("-qgraph="+FormatComboBox->currentText());
   completeOutputFiles(GraphLineEdit, "graph");
   } else if (DualRadioButton->isChecked()) {
      programConfiguration.append("-dual");
      programConfiguration.append("-dgraph="+FormatComboBox->currentText());
   completeOutputFiles(GraphLineEdit, "graph");
   }
}

void kdiffseq::beforeRunningProgram()
{
   completeOutputFiles(WriteFeatureTableAToLineEdit, "a.feat");
   completeOutputFiles(WriteFeatureTableBToLineEdit, "b.feat");
}

void kdigest::beforeRunningProgram()
{
   QString num;
   num.setNum(EnzymeOrReagentComboBox->currentIndex()+1);
   programConfiguration.append("-menu="+num);
   if (RaggingGroupBox->isChecked()) {
      num.setNum(TerminiComboBox->currentIndex()+1);
      programConfiguration.append("-termini="+num);
   }
}

void kdistmat::beforeRunningProgram()
{
   QString num;
   num.setNum(NucleicAcidMethodComboBox->currentIndex());
   programConfiguration.append("-nucmethod="+num);
   num.setNum(ProteinMethodComboBox->currentIndex());
   programConfiguration.append("-protmethod="+num);
}

kdotplot::kdotplot(kemboss *parent, const int &program) : kprogramWindow(parent)
{
   setupUi(this);
   loadFormats("graph_types", XYGraphFormatComboBox);
   postWindowCreated();
   kpwProgramComboBox->setCurrentIndex(program);
}

void kdotplot::on_ProgramComboBox_currentIndexChanged(const QString &text)
{
   bool setTo;
   if (text == "dotmatcher") setTo = true; else setTo = false;
      WindowSizeLabel->setEnabled(setTo);
      WindowSizeSpinBox->setEnabled(setTo);
      ThresholdLabel->setEnabled(setTo);
      ThresholdSpinBox->setEnabled(setTo);
      SubstitutionMatrixLabel->setEnabled(setTo);
      SubstitutionMatrixComboBox->setEnabled(setTo);
   if (text == "dotmatcher" || text == "dottup") setTo = true; else setTo = false;
      XYGraphFormatLabel->setEnabled(setTo);
      XYGraphFormatComboBox->setEnabled(setTo);
      NonProportionalGraphCheckBox->setEnabled(setTo);
   if (text == "dotpath" || text == "dottup") setTo = true; else setTo = false;
      WordSizeLabel->setEnabled(setTo);
      WordSizeSpinBox->setEnabled(setTo);
      DrawBoxCheckBox->setEnabled(setTo);
   if (text == "dotpath") {
      WordSizeSpinBox->setValue(4);
      DisplayOverlappingMatchesCheckBox->setEnabled(true);
   } else DisplayOverlappingMatchesCheckBox->setEnabled(false);
   if (text == "dottup")
      WordSizeSpinBox->setValue(10);
   setEmbossApp(ProgramComboBox->currentText());
}

kdrawmap::kdrawmap(kemboss *parent, const int &program) : kprogramWindow(parent)
{
   setupUi(this);
   loadFormats("colours", ColourOfJunctionsComboBox);
   postWindowCreated();
   kpwProgramComboBox->setCurrentIndex(program);
}

void kdrawmap::on_ProgramComboBox_currentIndexChanged(const QString &text)
{
   if (text == "cirdna") {
      MoleculesOriginOnTheCircleLabel->setEnabled(true);
      MoleculesOriginOnTheCircleDoubleSpinBox->setEnabled(true);
      JunctionsBetweenBlocksCheckBox->setEnabled(true);
      TypeOfJunctionsLabel->setEnabled(false);
      TypeOfJunctionsComboBox->setEnabled(false);
      WidthOfLeftMarginDoubleSpinBox->setEnabled(false);
      WidthOfLeftMarginLabel->setEnabled(false);
      BlockPositionComboBox->setEnabled(true);
      BlockPositionLabel->setEnabled(true);
      TickPositionLabel->setEnabled(true);
      TickPositionComboBox->setEnabled(true);
   } else if (text == "lindna") {
      MoleculesOriginOnTheCircleLabel->setEnabled(false);
      MoleculesOriginOnTheCircleDoubleSpinBox->setEnabled(false);
      JunctionsBetweenBlocksCheckBox->setEnabled(false);
      TypeOfJunctionsLabel->setEnabled(true);
      TypeOfJunctionsComboBox->setEnabled(true);
      WidthOfLeftMarginDoubleSpinBox->setEnabled(true);
      WidthOfLeftMarginLabel->setEnabled(true);
      BlockPositionComboBox->setEnabled(false);
      BlockPositionLabel->setEnabled(false);
      TickPositionLabel->setEnabled(false);
      TickPositionComboBox->setEnabled(false);
   }
   setEmbossApp(ProgramComboBox->currentText());
}

void kdrawmap::beforeRunningProgram()
{
   QString num;
   num.setNum(ColourOfJunctionsComboBox->currentIndex());
   programConfiguration.append("-intercolour="+num);
}

void kedialign::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "align");
   programConfiguration.append("-nucmode="+NucleicAcidAlignmentModeComboBox->currentText().section(" ", 0, 0));
   programConfiguration.append("-linkage="+ClusteringMethodComboBox->currentText().section(" ", 0, 0));
}

void keinverted::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "seq");
}

void kemma::beforeRunningProgram()
{
   if (KtupSpinBox->value() != -1) { programConfiguration.append("-ktup="+KtupSpinBox->text()); }
   if (GapPenaltySpinBox->value() != -1) { programConfiguration.append("-gapw="+GapPenaltySpinBox->text()); }
   if (TopDiagsSpinBox->value() != -1) { programConfiguration.append("-topdiags="+TopDiagsSpinBox->text()); }
   if (WindowSpinBox->value() != -1) { programConfiguration.append("-window="+WindowSpinBox->text()); }
   programConfiguration.append("-pwmatrix="+PASubstitutionMatrixComboBox->currentText().left(1));
   programConfiguration.append("-pwdnamatrix="+PADNASubstitutionMatrixComboBox->currentText().left(1));
   programConfiguration.append("-matrix="+MASubstitutionMatrixComboBox->currentText().left(1));
   programConfiguration.append("-dnamatrix="+MADNASubstitutionMatrixComboBox->currentText().left(1));
   completeOutputFiles(DendrogramFileLineEdit, "dend");
}

void kemowse::beforeRunningProgram()
{
   QString num;
   num.setNum(EnzymeComboBox->currentIndex()+1);
   programConfiguration.append("-enzyme="+num);
}

void keprimer3::beforeRunningProgram()
{
   if (WhatToDoComboBox->isEnabled()) {
      QString num;
      num.setNum(WhatToDoComboBox->currentIndex()+1);
      programConfiguration.append("-task="+num);
   }
}

void kextractfeat::beforeRunningProgram()
{
   programConfiguration.append("-sense="+SenseComboBox->currentText().section(" ", 0, 0));
}

void kfindkm::beforeRunningProgram()
{
   if (CreateGraphGroupBox->isChecked()) completeOutputFiles(OutputFileLineEdit2, "graph");
}

void kfreak::beforeRunningProgram()
{
   if (CreateGraphGroupBox->isChecked()) completeOutputFiles(OutputFileLineEdit2, "graph");
}

void kisochore::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "graph");
}

void kgetorf::beforeRunningProgram()
{
   programConfiguration.append("-table="+GeneticCodeComboBox->currentText().section(" ", 0, 0));
   QString num;
   num.setNum(OutputComboBox->currentIndex());
   programConfiguration.append("-find="+num);
}

void khmoment::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "graph");
}

void kiep::beforeRunningProgram()
{
   if (CreateGraphGroupBox->isChecked()) completeOutputFiles(OutputFileLineEdit2, "graph");
}

void kinfo::on_ProgramComboBox_currentIndexChanged(int value)
{
   bool boolean;
   if (value == 0) {
      setEmbossApp("infobase");
      boolean = false;
   } else {
      boolean = true;
      setEmbossApp("inforesidue");
   }
   AAPropertiesFileLabel->setEnabled(boolean);
   AAPropertiesFileLineEdit->setEnabled(boolean);
   AAPropertiesFilePushButton->setEnabled(boolean);
   AAMolWeightLabel->setEnabled(boolean);
   AAMolWeightLineEdit->setEnabled(boolean);
   AAMolWeightPushButton->setEnabled(boolean);
}

void kjaspscan::beforeRunningProgram()
{
   programConfiguration.append("-menu="+MatrixSetComboBox->currentText().left(1));
}

void klistor::beforeRunningProgram()
{
   programConfiguration.append("-operator="+LogicalOperatorComboBox->currentText().section(" ", 0, 0));
}

void kmakeseq::on_ProgramComboBox_currentIndexChanged(const QString &text)
{
   if (text == "Nucleic acid") {
      DataFileLineEdit->setToolTip("codonfile");
      setEmbossApp("makenucseq");
   } else if (text == "Protein") {
      DataFileLineEdit->setToolTip("pepstatsfile");
      setEmbossApp("makeprotseq");
   }
}

void kmegamerger::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "seq");
}

void kmerger::beforeRunningProgram()
{
   completeOutputFiles(MergedSequenceLineEdit, "merged");
}

void kmodifyseq::setEmbossApp(const QString &appName)
{
   DeleteRegionGroupBox->setChecked(false);
   SplitterGroupBox->setChecked(false);
   RemoveGapCharactersGroupBox->setChecked(false);
   PasteseqGroupBox->setChecked(false);
   ExcludeSequencesGroupBox->setChecked(false);
   ExtractseqGroupBox->setChecked(false);
   ExtractalignGroupBox->setChecked(false);
   MaskRegionGroupBox->setChecked(false);
   ReverseComplementGroupBox->setChecked(false);
   ShuffleSequenceGroupBox->setChecked(false);
   DescseqGroupBox->setChecked(false);
   BiosedGroupBox->setChecked(false);
   MaskAmbiguityCaractersNGroupBox->setChecked(false);
   MaskAmbiguityCaractersPGroupBox->setChecked(false);
   SortBySizeGroupBox->setChecked(false);

   if (appName == "cutseq") DeleteRegionGroupBox->setChecked(true);
   else if (appName == "splitter") SplitterGroupBox->setChecked(true);
   else if (appName == "degapseq") RemoveGapCharactersGroupBox->setChecked(true);
   else if (appName == "pasteseq") PasteseqGroupBox->setChecked(true);
   else if (appName == "notseq") ExcludeSequencesGroupBox->setChecked(true);
   else if (appName == "extractseq") ExtractseqGroupBox->setChecked(true);
   else if (appName == "extractalign") ExtractalignGroupBox->setChecked(true);
   else if (appName == "maskseq") MaskRegionGroupBox->setChecked(true);
   else if (appName == "revseq") ReverseComplementGroupBox->setChecked(true);
   else if (appName == "shuffleseq") ShuffleSequenceGroupBox->setChecked(true);
   else if (appName == "descseq") DescseqGroupBox->setChecked(true);
   else if (appName == "biosed") BiosedGroupBox->setChecked(true);
   else if (appName == "maskambignuc") MaskAmbiguityCaractersNGroupBox->setChecked(true);
   else if (appName == "maskambigprot") MaskAmbiguityCaractersPGroupBox->setChecked(true);
   else if (appName == "sizeseq") SortBySizeGroupBox->setChecked(true);

   disconnect(OutseqAssociatedQualifiersPushButton, SIGNAL(clicked()),0,0);
   if (appName == "pasteseq") {
      connect(OutseqAssociatedQualifiersPushButton, SIGNAL(clicked()), this, SLOT(outseqAssociatedQualifiersPushButton2_clicked()));
      InputFileLineEdit->setToolTip("asequence");
   } else if (appName == "notseq") {
      connect(OutseqAssociatedQualifiersPushButton, SIGNAL(clicked()), this, SLOT(outseqAssociatedQualifiersPushButton2_clicked()));
      InputFileLineEdit->setToolTip("sequence");
   } else if (appName == "sizeseq") {
      InputFileLineEdit->setToolTip("sequences");
      connect(OutseqAssociatedQualifiersPushButton, SIGNAL(clicked()), this, SLOT(openOsAQForm()));
   } else {
      connect(OutseqAssociatedQualifiersPushButton, SIGNAL(clicked()), this, SLOT(openOsAQForm()));
      InputFileLineEdit->setToolTip("sequence");
   }
   kprogramWindow::setEmbossApp(appName);
}

void kmsbar::beforeRunningProgram()
{
   QString num;
   num.setNum(PerformPointMutationsComboBox->currentIndex());
   programConfiguration.append("-point="+num);
   num.setNum(PerformCodonMutationsComboBox->currentIndex());
   programConfiguration.append("-codon="+num);
   num.setNum(PerformBlockMutationsComboBox->currentIndex());
   programConfiguration.append("-block="+num);
}

void knewseq::beforeRunningProgram()
{
   programConfiguration.append("-type="+SequenceTypeComboBox->currentText().left(1));
}

void kno::on_ProgramComboBox_currentIndexChanged(const QString &text)
{
   TargetSystemLabel->setEnabled(false);
   TargetSystemComboBox->setEnabled(false);
   if (text == "noreturn") {
      TargetSystemLabel->setEnabled(true);
      TargetSystemComboBox->setEnabled(true);
   }
   setEmbossApp(text);
}

kpepdisplay::kpepdisplay(kemboss *parent, const int &program) : kprogramWindow(parent)
{
   setupUi(this);
   postWindowCreated();
   kpwProgramComboBox->setCurrentIndex(program);
}

void kpepdisplay::on_ProgramComboBox_currentIndexChanged(const QString &text)
{
   bool setTo;
   if (text == "wheel") {
      setTo = true;
      setEmbossApp("pepwheel");
   } else {
      setTo = false;
      setEmbossApp("pepnet");
   }
   StepsLabel->setEnabled(setTo);
   StepsSpinBox->setEnabled(setTo);
   TurnsLabel->setEnabled(setTo);
   TurnsSpinBox->setEnabled(setTo);
   PlotWheelCheckBox->setEnabled(setTo);
}

void kpepinfo::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "graph");
}

void kpepwindow::on_SuperimposePlotsCheckBox_stateChanged(int state)
{
   if (state == Qt::Checked) setEmbossApp("pepwindowall"); else setEmbossApp("pepwindow");
}

void kpolydot::beforeRunningProgram()
{
   if (DumpAllMatchesAsFeatureFilesCheckBox->isChecked()) completeOutputFiles(FeaturesFileLineEdit, "feat");
}

kprettyplot::kprettyplot(kemboss *parent) : kprogramWindow(parent)
{
   setupUi(this);
   loadFormats("colours", BackgroundColorComboBox);
   loadFormats("colours", IdenticalComboBox);
   loadFormats("colours", SimilarComboBox);
   loadFormats("colours", OtherComboBox);
   postWindowCreated();
}

void kprettyplot::beforeRunningProgram()
{
   if (PluralityDoubleSpinBox->value()!=-1) {
      QString num;
      num.setNum(PluralityDoubleSpinBox->value());
      programConfiguration.append("-plurality="+num);
   }
}

void kprettyseq::beforeRunningProgram()
{
   programConfiguration.append("-table="+GeneticCodeComboBox->currentText().section(" ", 0, 0));
}

void kprophecy::beforeRunningProgram()
{
   programConfiguration.append("-type="+TypeComboBox->currentText().left(1));
}

kredata::kredata(kemboss *parent) : kprogramWindow(parent)
{
   setupUi(this);
   postWindowCreated();
   EnzymeComboBox->addItems(loadRebaseEnzymes());
}

kremap::kremap(kemboss *parent) : kprogramWindow(parent)
{
   setupUi(this);
   postWindowCreated();
   AvailableEnzymesListWidget->addItems(loadRebaseEnzymes());
}

void kremap::on_AddEnzymePushButton_clicked()
{
   QListWidgetItem *selectedItem = NULL;
   selectedItem = AvailableEnzymesListWidget->currentItem();
   if (selectedItem != NULL) EnzymesListWidget->addItem(selectedItem->text());
}

void kremap::on_RemoveEnzymePushButton_clicked()
{
   QListWidgetItem *curItem = EnzymesListWidget->takeItem(EnzymesListWidget->currentRow());
   delete curItem;
}

void kremap::on_SaveEnzymeListAsPushButton_clicked()
{
   saveEnzymeList(EnzymesListWidget);
}

void kremap::beforeRunningProgram()
{
   if (AllEnzymesRadioButton->isChecked())
      programConfiguration.append("-enzymes=all");
   else if (SelectFromREBASERadioButton->isChecked())
      programConfiguration.append(selectedEnzymes(EnzymesListWidget));
   else if (UseListRadioButton->isChecked())
      programConfiguration.append("-enzymes=@"+UseListLineEdit->text());

   programConfiguration.append("-table="+GeneticCodeComboBox->currentText().section(" ", 0, 0));
   programConfiguration.append("-frame="+FramesComboBox->currentText().section(" ", 0, 0));
}

kremutate::kremutate(kemboss *parent, const int &program) : kprogramWindow(parent)
{
   setupUi(this);
   postWindowCreated();
   AvailableEnzymesListWidget->addItems(loadRebaseEnzymes());
   kpwProgramComboBox->setCurrentIndex(program);
}

void kremutate::on_ProgramComboBox_currentIndexChanged(const QString &text)
{
   if (text == "silent") {
      AllMutationsCheckBox->setEnabled(true);
   } else if (text == "recoder") {
      AllMutationsCheckBox->setEnabled(false);
   }
   setEmbossApp(text);
}

void kremutate::on_AddEnzymePushButton_clicked()
{
   QListWidgetItem *selectedItem = NULL;
   selectedItem = AvailableEnzymesListWidget->currentItem();
   if (selectedItem != NULL) EnzymesListWidget->addItem(selectedItem->text());
}

void kremutate::on_RemoveEnzymePushButton_clicked()
{
   QListWidgetItem *curItem = EnzymesListWidget->takeItem(EnzymesListWidget->currentRow());
   delete curItem;
}

void kremutate::on_SaveEnzymeListAsPushButton_clicked()
{
   saveEnzymeList(EnzymesListWidget);
}

void kremutate::beforeRunningProgram()
{
   if (AllEnzymesRadioButton->isChecked())
      programConfiguration.append("-enzymes=all");
   else if (SelectFromREBASERadioButton->isChecked())
      programConfiguration.append(selectedEnzymes(EnzymesListWidget));
   else if (UseListRadioButton->isChecked())
      programConfiguration.append("-enzymes=@"+UseListLineEdit->text());
}

krestrict::krestrict(kemboss *parent) : kprogramWindow(parent)
{
   setupUi(this);
   postWindowCreated();
   AvailableEnzymesListWidget->addItems(loadRebaseEnzymes());
}

void krestrict::on_AddEnzymePushButton_clicked()
{
   QListWidgetItem *selectedItem = NULL;
   selectedItem = AvailableEnzymesListWidget->currentItem();
   if (selectedItem != NULL) EnzymesListWidget->addItem(selectedItem->text());
}

void krestrict::on_RemoveEnzymePushButton_clicked()
{
   QListWidgetItem *curItem = EnzymesListWidget->takeItem(EnzymesListWidget->currentRow());
   delete curItem;
}

void krestrict::on_SaveEnzymeListAsPushButton_clicked()
{
   saveEnzymeList(EnzymesListWidget);
}

void krestrict::beforeRunningProgram()
{
   if (AllEnzymesRadioButton->isChecked())
      programConfiguration.append("-enzymes=all");
   else if (SelectFromREBASERadioButton->isChecked())
      programConfiguration.append(selectedEnzymes(EnzymesListWidget));
   else if (UseListRadioButton->isChecked())
      programConfiguration.append("-enzymes=@"+UseListLineEdit->text());
}

void kseq::on_ProgramComboBox_currentIndexChanged(const QString &text)
{
   UseFeatureInformationCheckBox->setEnabled(true);
   ReadOnlyOneSequenceCheckBox->setEnabled(false);
   if (text == "skipseq") {
      NumberLabel->setEnabled(true);
      NumberSpinBox->setEnabled(true);
      NumberSpinBox->setToolTip("skip");
   } else if (text == "nthseq") {
      NumberLabel->setEnabled(true);
      NumberSpinBox->setEnabled(true);
      NumberSpinBox->setToolTip("number");
      UseFeatureInformationCheckBox->setEnabled(false);
   } else {
      NumberLabel->setEnabled(false);
      NumberSpinBox->setEnabled(false);
      ReadOnlyOneSequenceCheckBox->setEnabled(true);
   }
   if (text == "entret") {
      OutputFileLineEdit->setToolTip("outfile");
      UseFeatureInformationCheckBox->setEnabled(false);
   } else {
      OutputFileLineEdit->setToolTip("outseq");
   }
   setEmbossApp(text);
}

void kshowalign::beforeRunningProgram()
{
   programConfiguration.append("-show="+ShowComboBox->currentText().left(1));
   programConfiguration.append("-order="+OutputOrderComboBox->currentText().left(1));
   if (UpperCaseDoubleSpinBox->value()!=-1) {
      QString num;
      num.setNum(UpperCaseDoubleSpinBox->value());
      programConfiguration.append("-setcase="+num);
   }
}

void kshowfeat::beforeRunningProgram()
{
   programConfiguration.append("-sort="+SortByComboBox->currentText().section(" ", 0, 0));
}

void kshoworf::beforeRunningProgram()
{
   programConfiguration.append("-table="+GeneticCodeComboBox->currentText().section(" ", 0, 0));
   QString frames = "";
   if (CheckBox1->isChecked()) frames+="1,";
   if (CheckBox2->isChecked()) frames+="2,";
   if (CheckBox3->isChecked()) frames+="3,";
   if (CheckBox4->isChecked()) frames+="4,";
   if (CheckBox5->isChecked()) frames+="5,";
   if (CheckBox6->isChecked()) frames+="6,";
   frames.chop(1);
   programConfiguration.append("-frames="+frames);
}

kshowseq::kshowseq(kemboss *parent) : kprogramWindow(parent)
{
   setupUi(this);
   postWindowCreated();
   AvailableEnzymesListWidget->addItems(loadRebaseEnzymes());
}

void kshowseq::on_AddEnzymePushButton_clicked()
{
   QListWidgetItem *selectedItem = NULL;
   selectedItem = AvailableEnzymesListWidget->currentItem();
   if (selectedItem != NULL) EnzymesListWidget->addItem(selectedItem->text());
}

void kshowseq::on_RemoveEnzymePushButton_clicked()
{
   QListWidgetItem *curItem = EnzymesListWidget->takeItem(EnzymesListWidget->currentRow());
   delete curItem;
}

void kshowseq::on_SaveEnzymeListAsPushButton_clicked()
{
   saveEnzymeList(EnzymesListWidget);
}

void kshowseq::beforeRunningProgram()
{
   QString num;
   num.setNum(OutputFormatComboBox->currentIndex());
   programConfiguration.append("-format="+num);
   if (AllEnzymesRadioButton->isChecked())
      programConfiguration.append("-enzymes=all");
   else if (SelectFromREBASERadioButton->isChecked())
      programConfiguration.append(selectedEnzymes(EnzymesListWidget));
   else if (UseListRadioButton->isChecked())
      programConfiguration.append("-enzymes=@"+UseListLineEdit->text());
   programConfiguration.append("-table="+GeneticCodeComboBox->currentText().section(" ", 0, 0));
   num.setNum(SenseComboBox->currentIndex()-1);
   programConfiguration.append("-sensematch="+num);
}

void kshowpep::beforeRunningProgram()
{
   QString num;
   num.setNum(OutputFormatComboBox->currentIndex());
   programConfiguration.append("-format="+num);
}

void ksirna::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "seq");
}

void ksixpack::beforeRunningProgram()
{
   programConfiguration.append("-table="+GeneticCodeComboBox->currentText().section(" ", 0, 0));
   completeOutputFiles(OutputFileLineEdit2, "translation");
}

void kskipredundant::on_ModeComboBox_currentIndexChanged(int value)
{
   bool boolean;
   if (value == 0) 
      boolean = false;
   else 
      boolean = true;
   ThresholdLabel->setEnabled(!boolean);
   ThresholdDoubleSpinBox->setEnabled(!boolean);
   MinThresholdLabel->setEnabled(boolean);
   MinThresholdDoubleSpinBox->setEnabled(boolean);
   MaxThresholdLabel->setEnabled(boolean);
   MaxThresholdDoubleSpinBox->setEnabled(boolean);
}

void kskipredundant::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "seq");
   QString num;
   num.setNum(ModeComboBox->currentIndex()+1);
   programConfiguration.append("-mode="+num);
}

void ksyco::beforeRunningProgram()
{
   programConfiguration.append("-cfile="+CodonUsageFileComboBox->currentText().section(" ", 0, 0));
   completeOutputFiles(OutputFileLineEdit2, "graph");
}

void ktcode::beforeRunningProgram()
{
   if (CreateGraphCheckBox->isChecked()) completeOutputFiles(GraphOutputFileLineEdit, "graph");
}

void ktfscan::beforeRunningProgram()
{
   programConfiguration.append("-menu="+ClassComboBox->currentText().left(1));
}

void ktmap::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "graph");
}

void ktranalign::beforeRunningProgram()
{
   programConfiguration.append("-table="+GeneticCodeComboBox->currentText().section(" ", 0, 0));
}

void ktranseq::beforeRunningProgram()
{
   programConfiguration.append("-table="+GeneticCodeComboBox->currentText().section(" ", 0, 0));
   programConfiguration.append("-frame="+FramesComboBox->currentText().section(" ", 0, 0));
}

void ktwofeat::beforeRunningProgram()
{
   programConfiguration.append("-asense="+SenseComboBox->currentText().section(" ", 0, 0));
   programConfiguration.append("-bsense="+SenseComboBox_2->currentText().section(" ", 0, 0));
   programConfiguration.append("-overlap="+OverlapComboBox->currentText().section(" ", 0, 0));
   programConfiguration.append("-rangetype="+TypeOfRangeComboBox->currentText().section(" ", 0, 0));
   programConfiguration.append("-sense="+SenseComboBox_3->currentText().left(1));
   programConfiguration.append("-order="+OrderComboBox->currentText().section(" ", 0, 0));
}

void kvectorstrip::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "seq");
}

void kwobble::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "graph");
}

void kwordmatch::beforeRunningProgram()
{
   completeOutputFiles(OutputFileLineEdit2, "feat_a");
   completeOutputFiles(OutputFileLineEdit3, "feat_b");
}
